Attribute VB_Name = "General"
Option Explicit

Global Const MF_BYPOSITION = &H400&
Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long
Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long

Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long

Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Global Const OF_READ = &H0&
Declare Function lOpen Lib "kernel32" Alias "_lopen" (ByVal lpPathName As String, ByVal iReadWrite As Long) As Long
Declare Function lclose Lib "kernel32" Alias "_lclose" (ByVal hFile As Long) As Long

Global Const COLORONCOLOR = 3
Global Const HALFTONE = 4


Global Const SWP_NOMOVE = 2
Global Const SWP_NOSIZE = 1
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2
Global Const FLOAT = 1, SINK = 0

Public Declare Sub SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Sub CopyMemory Lib "kernel32" _
                               Alias "RtlMoveMemory" (Destination As Any, Source As Any, _
                                                      ByVal Length As Long)

Private Declare Function lstrlenA Lib "kernel32" _
                                  (ByVal lpString As Long) As Long

Private Declare Function lstrlenW Lib _
                                  "kernel32" (ByVal lpString As Long) As Long
Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Boolean
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Public otherinstance As Long
Private Declare Function RegisterWindowMessage Lib "user32" Alias _
                                               "RegisterWindowMessageA" (ByVal lpString As String) As Long
Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" _
                                 (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam _
                                                                          As Long, ByVal lParam As Long) As Long

Public Const MSG_OPENMAP = "DCME_OPENMAP"

Public Function WM_DCME_OPENMAP() As Long
    Static msg As Long

    If msg = 0 Then
        msg = RegisterWindowMessage(MSG_OPENMAP)
    End If

    WM_DCME_OPENMAP = msg

End Function

Sub DrawRectangle(pic As PictureBox, Left As Integer, Right As Integer, Top As Integer, Bottom As Integer, color As Long, Optional adjust As Integer)
    Dim oldcolor As Long
    oldcolor = pic.ForeColor
    pic.ForeColor = color

    Dim adj As Integer
    If IsMissing(adjust) Then
        adj = 0
    Else
        adj = adjust
    End If

    pic.Line (Left - adj, Top - adj)-(Right + adj, Top - adj)
    pic.Line (Right + adj, Top - adj)-(Right + adj, Bottom + adj)
    pic.Line (Right + adj, Bottom + adj)-(Left - adj, Bottom + adj)
    pic.Line (Left - adj, Bottom + adj)-(Left - adj, Top - adj)

    pic.FillColor = oldcolor

End Sub

Function GetFileTitle(path As String)
    Dim temp() As String
    Dim output As String

    If path = "" Then
        GetFileTitle = ""
        Exit Function
    End If

    temp = Split(path, "\")

    output = temp(UBound(temp))
    If output = "" Then
        output = temp(UBound(temp) - 1)
    End If

    GetFileTitle = output
End Function


Function GetExtention(filetitle As String)
    Dim temp() As String
    Dim output As String
    temp = Split(filetitle, ".")
    If UBound(temp) < 0 Then
        GetExtention = ""
        Exit Function
    End If

    output = temp(UBound(temp))

    GetExtention = output
End Function

Sub removeDisallowedCharacters(ByRef txtbox As TextBox, Optional boundTo1024 As Boolean = False)
    If Not IsNumeric(txtbox.text) Or InStr(txtbox.text, "e") > 0 Or InStr(txtbox.text, ".") > 0 Then
        Dim oldselstart As Integer
        oldselstart = txtbox.SelStart - 1    'char  typed so always one more
        If oldselstart < 0 Then oldselstart = 0

        'remove all characters aside from nrs
        Dim i As Integer
        Dim finalresult As String
        For i = 1 To Len(txtbox.text)
            If Asc(Mid$(txtbox.text, i, 1)) < Asc("0") Or _
               Asc(Mid$(txtbox.text, i, 1)) > Asc("9") Then
                Dim result As String
                If i - 1 >= 1 Then result = Mid$(txtbox.text, 1, i - 1)
                If i + 1 <= Len(txtbox.text) Then result = result + Mid$(txtbox.text, i + 1, Len(txtbox.text) - (i))
                finalresult = result
            End If
        Next
        txtbox.text = finalresult
        If oldselstart > Len(txtbox.text) Then
            txtbox.SelStart = Len(txtbox.text)
        Else
            txtbox.SelStart = oldselstart
        End If
    End If

    If boundTo1024 Then
        If val(txtbox.text) < 0 Then
            txtbox.text = 0
        End If

        If val(txtbox.text) >= 1024 Then
            txtbox.text = 1024
        End If
    End If
End Sub

Function PointerToString(lngPtr As Long) As String
'--------------------------------------------------------
'RETURNS A STRING FROM IT'S POINTER
'EXAMPLE:
'-- Generate pointer for demo purposes

'Dim l As Long
'Dim s As String
's = "THIS IS A TEST"
'l = StrPtr(s)

'--We have the pointer, call the function

'MsgBox PointerToString(l)

'NOTE: THE ASSUMPTION IS THAT THE POINTER IS TO A UNICODE STRING
'IF NOT, CHANGE THE FUNCTION AS FOLLOWS (UNTESTED)
'-- Change lstrlenW to lStrLena
'-- Get rid of the * 2
'-- The replace statement should not be necessary, just return strTemp
'----------------------------------------------------------

    Dim strTemp As String
    Dim lngLen As Long


    If lngPtr Then
        lngLen = lstrlenW(lngPtr) * 2
        If lngLen Then
            strTemp = Space(lngLen)
            CopyMemory ByVal strTemp, ByVal lngPtr, lngLen
            PointerToString = replace(strTemp, Chr(0), "")
        End If
    End If
End Function

Function EnumWindowsProc(ByVal hWnd As Long, ByVal lParam As Long) As Boolean
    Dim sSave As String, ret As Long
    ret = GetWindowTextLength(hWnd)
    sSave = Space(ret)
    GetWindowText hWnd, sSave, ret + 1
    'continue enumeration

    If InStr(sSave, "Drake Continuum Map Editor") > 0 Then
        Dim strclass As String
        strclass = String$(50, Chr(0))
        Call GetClassName(hWnd, strclass, 50)

        If hWnd <> frmGeneral.hWnd And InStr(strclass, "ThunderRT6MDIForm") > 0 Then
            'found other instance
            otherinstance = hWnd
            Exit Function
        End If
    End If

    EnumWindowsProc = True
End Function

Function GetLongFilename(ByRef sShortName As String) As String
    Dim sTemp As String
    Dim sLongName As String
    Dim lSlashPos As Long

    If Right$(sShortName, 1) <> "\" Then sShortName = sShortName & "\"
    lSlashPos = InStr(4, sShortName, "\")    ' start past x:\

    Do While lSlashPos
        sTemp = Dir$(Left$(sShortName, lSlashPos - 1), vbNormal Or vbHidden Or vbSystem Or vbDirectory)
        If LenB(sTemp) = 0 Then Exit Function
        sLongName = sLongName & "\" & sTemp
        lSlashPos = InStr(lSlashPos + 1, sShortName, "\")
    Loop

    GetLongFilename = Left$(sShortName, 2) & sLongName
End Function


Function inDebug()
    bDEBUG = True
    inDebug = True
End Function

















''/* Arguments:
'' *        Pointer to bitmap to fill, (x,y) coordinates of seed point,
'' *        color used for solid or masked fills, border color used if area to
'' *        be filled is outlined (or CLR_INVALID).
'' *
'' * Returns:
'' *         0 = Success.
'' *        -1 = Invalid seed point.
'' *        -2 = Memory allocation error.
'' *        -3 = Invalid bitmap or unknown error.
'' */
'
'Dim m_CurStackSize As Long
'Dim m_MaxStackSize As Long
'Dim m_VisitSize As Long
'Dim m_CurrentLine As Long
'
'Dim m_bXSortOn As Boolean
'Dim m_bMemError As Boolean
'Dim m_LastY As Integer
'
'Function QuickFill(pic As PictureBox, x As Integer, y As Integer, fill_color As Long, border_color As Long) As Long
'
'    Dim ThisColor  As Long
'    Dim MaxY As Integer
'    Dim MaxX As Integer
'    Dim Dy As Integer
'    Dim ChildLeft As Integer
'    Dim ChildRight As Integer
'    Dim ParentLeft As Integer
'    Dim ParentRight As Integer
'
'    m_CurStackSize = 0
'    m_MaxStackSize = 0
'    m_VisitSize = 0
'
'    m_CurrentLine = 0
'    m_bXSortOn = False
'    m_bMemError = False
'    m_LastY = -1
'
'    '/* Initialize internal info based on fill type */
'    If clr_invalid <> border_color Then
'        '/* Check color at x,y position */
'        ThisColor = GetPixel(pic.hdc, x, y)
'
'        If ThisColor = border_color Then
'            QuickFill = -1
'            Exit Function
'        End If
'
'        ThisColor = BorderColor
'        m_bXSortOn = True
'    Else
'        '/* Check color at x,y position */
'        ThisColor = GetPixel(pic.hdc, x, y)
'
'        ' //////// what is m_DibPattern.GetDibPtr() ???
'
'        If ThisColor = fill_color Then  'and not m_DibPattern.GetDibPtr()
'            QuickFill = -1
'            Exit Function
'        End If
'
'        ' ///////// what's this ?????
'
'        'if( m_DibPattern.GetDibPtr() || memcmp(m_FillMask,_SolidMask,8) )
'        '    m_bXSortOn = TRUE;
'    End If
'
'    '/////////// how can i do this in vb ????
'
'    '/* Using macros because we can not uses pointer to member functions.
'    ' * This makes the code less efficient, but solves the problem.
'    ' */
''#define FindLeft(x,y,xmin,color) \
''    ((CLR_INVALID != border_color) \
''    ? SearchLeft(x,y,xmin,color) : ScanLeft(x,y,xmin,color))
''#define FindRight(x,y,xmax,color) \
''    ((CLR_INVALID != border_color) \
''    ? SearchRight(x,y,xmax,color) : ScanRight(x,y,xmax,color))
''#define SkipRight(x,y,xmax,color) \
''    ((CLR_INVALID != border_color) \
''    ? ScanRight(x,y,xmax,color) : SearchRight(x,y,xmax,color))
'
'
'    ' //////////// eh ?
'
'    '/* Initialize Line list */
'    'if( MakeList() )
'    '    return -2;
'
'    '/* Initialize maximum coords */
'    MaxX = pic.ScaleWidth - 1
'    MaxY = pic.ScaleHeight - 1
'
'    '/* Push starting point on stack */
'    Call PushLine(x, x, y, 1) '/* Needed in one special case */
'    Call PushLine(x, x, y + 1, -1)
'
'    '/* Now start flooding */
'    Do While m_plinelist
'        Call PopLine(ParentLeft, ParentRight, y, Dy)
'        y = y + Dy
'        If y < 0 Or MaxY < y Then
'            ' what is continue ? exit do ?
'            'continue;
'        End If
'        If m_bMemError Then
'            'continue;
'        End If
'        If m_bXSortOn And isrevisit(ParentLeft, ParentRight, y) Then
'            'continue;
'        End If
'    Loop
'
'    '/* Find ChildLeft end ( ChildLeft>ParentLeft on failure ) */
'    ChildLeft = FindLeft(ParentLeft, y, 0, ThisColor) + 1
'    If ChildLeft <= ParentLeft Then
'        '/* Find ChildRight end ( this should not fail here ) */
'        ChildRight = FindRight(ParentLeft, y, MaxX, ThisColor) - 1
'
'        If ChildLeft = ChildRight Then
'            Call SetPixel(pic.hdc, x, y, fill_color)
'        Else
'            Line (ChildLeft, ChildRight)-(y, fill_color)
'        End If
'
'        '/* Push unvisited lines */
'        If ParentLeft - 1 <= ChildLeft And ChildRight <= ParentRight + 1 Then
'            Call PushLine(ChildLeft, ChildRight, y, Dy)
'        Else
'            If m_bXSortOn Then
'                Call PushOpposite(ParentLeft, ParentRight, ChildLeft, ChildRight, y, Dy)
'            Else
'                Call PushLine(ChildLeft, ChildRight, y, -Dy)
'            End If
'            Call PushLine(ChildLeft, ChildRight, y, Dy)
'        End If
'
'        '/* Addvance ChildRight end on to border */
'        ChildRight = ChildRight + 1
'    Else
'        ChildRight = ParentLeft
'    End If
'
'    '/* Fill betweens */
'
'    Do While ChildRight < ParentRight
'        '/* Skip to new ChildLeft end, ( ChildRight>ParentRight on failure ) */
'        ChildRight = SkipRight(ChildRight, y, ParentRight, ThisColor)
'        If ChildRight <= ParentRight Then
'            ChildLeft = ChildRight
'            '/* Find ChildRight end ( this should not fail here ) */
'            ChildRight = FindRight(ChildLeft, y, MaxX, ThisColor) - 1
'            '/* Fill line */
'            If ChildLeft = ChildRight Then
'                Call SetPixel(pic.hdc, ChildRight, y, fill_color)
'            Else
'                Line (ChildLeft, ChildRight)-(y, fill_color)
'            End If
'
'            '/* Push unvisited lines */
'            If ChildRight <= ParentRight + 1 Then
'                Call PushLine(ChildLeft, ChildRight, y, Dy)
'            Else
'                If m_bXSortOn Then
'                    Call PushOpposite(ParentLeft, ParentRight, ChildLeft, ChildRight, y, Dy)
'                Else
'                    Call PushLine(ChildLeft, ChildRight, y, -Dy)
'                End If
'                Call PushLine(ChildLeft, ChildRight, y, Dy)
'            End If
'
'            '/* Addvance ChildRight end onto border */
'            ChildRight = ChildRight + 1
'        End If
'    Loop
'
'    '/* Push visited line onto visited stack */
'    If m_bXSortOn Then
'        Call PushVisitedLine(ParentLeft, ParentRight, y)
'    End If
'
'    '??
'    Call FreeList
'    'm_DibData.SetDIBits(pBitmap);
'    'm_DibData.DeleteObject();
'
'    QuickFill = IIf(m_bMemError, -2, 0)
'
'End Function
