VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Magnifier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim c_zoom As Single
Dim c_UsingPixels As Boolean
Dim parent As frmMain

Sub setParent(ByRef myparent As frmMain)
    Set parent = myparent
    parent.currentzoom = c_zoom
    parent.currenttilew = c_zoom * TileW
End Sub

Private Sub Class_Initialize()
    c_zoom = 1
    c_UsingPixels = False
End Sub

Public Property Get Zoom() As Single
    Zoom = c_zoom
End Property

Public Property Get UsingPixels() As Boolean
    UsingPixels = c_UsingPixels
End Property

Sub MouseDown(Button As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    curtilex = (Int(((parent.hScr.value + x)) / (TileW * c_zoom)))
    curtiley = (Int(((parent.vScr.value + y)) / (TileW * c_zoom)))
    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
        Exit Sub
    End If

    If Button = vbLeftButton Then
        'when selecting, then zooming, the update for
        'selection requires not to have mouse down
        'so we need to put in before zooming, instead
        'of automaticly after
        SharedVar.MouseDown = False
        Call ZoomIn(curtilex, curtiley)
    Else
        SharedVar.MouseDown = False
        Call ZoomOut(curtilex, curtiley)
    End If
End Sub

Sub MouseMove()

End Sub

Sub MouseUp()
'nothing to do on mouseup
End Sub

Sub ZoomIn(tileX As Integer, tileY As Integer)

'dont zoom in more than 2
    On Error GoTo ZoomIn_Error

    If c_zoom = 2 Then Exit Sub

    If c_zoom = 1 / 16 Then
        'go back to normal tile level instead of pixel level
        c_zoom = 1 / 4
        If parent.sel.selstate = append Or parent.sel.selstate = drawing Then
            'remove selections when changing from pixel to tile level

            'parent.sel.StopSelecting
        End If

        c_UsingPixels = False
    Else
        c_zoom = c_zoom * 2
    End If

    parent.currentzoom = c_zoom
    parent.currenttilew = c_zoom * TileW

    parent.UpdateScrollBars

    'recalculate the scrollbars
    'this will make sure that the tile (or pixel on pixel level)
    'which was click on, will be in center of preview after zoom
    Dim newH As Integer
    Dim newV As Integer
    If Int((TileW * c_zoom)) * tileX - Int(parent.picpreview.Width / 2) < 0 Then
        newH = 0
    ElseIf Int((TileW * c_zoom)) * tileX - Int(parent.picpreview.Width / 2) > parent.hScr.Max Then
        newH = parent.hScr.Max
    Else
        newH = Int((TileW * c_zoom)) * tileX - Int(parent.picpreview.Width / 2)
    End If

    If Int((TileW * c_zoom)) * tileY - Int(parent.picpreview.Height / 2) < 0 Then
        newV = 0
    ElseIf Int((TileW * c_zoom)) * tileY - Int(parent.picpreview.Height / 2) > parent.vScr.Max Then
        newV = parent.vScr.Max
    Else
        newV = Int((TileW * c_zoom)) * tileY - Int(parent.picpreview.Height / 2)
    End If

    'make a correction so the value is always divisible
    'by tilew*zoom or TileW*zoom !
    newH = Int(newH / (TileW * c_zoom)) * (TileW * c_zoom)
    newV = Int(newV / (TileW * c_zoom)) * (TileW * c_zoom)

    Call parent.setScrollBarValues(newH, newV, False)

    'build the zoomed tileset:

    'make it the correct size
    parent.piczoomtileset.Width = parent.pictileset.Width * c_zoom
    parent.piczoomtileset.Height = parent.pictileset.Height * c_zoom


    'stretchblt the normal tileset to it
    With parent
        SetStretchBltMode .piczoomtileset.hdc, HALFTONE
        StretchBlt .piczoomtileset.hdc, 0, 0, .piczoomtileset.Width, .piczoomtileset.Height, .pictileset.hdc, 0, 0, .pictileset.Width, .pictileset.Height, vbSrcCopy
        .piczoomtileset.refresh
    End With

    parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

ZoomIn_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ZoomIn of Class Module Magnifier"

End Sub

Sub ZoomOut(tileX As Integer, tileY As Integer)
'dont c_zoom out when reached max c_zoom out level
    On Error GoTo ZoomOut_Error

    If c_zoom = 1 / 16 Then Exit Sub

    If c_zoom = 1 / 4 Then
        c_UsingPixels = True
        If parent.sel.selstate = append Or parent.sel.selstate = drawing Then
            'same as above, remove selections when changing from
            'tile level to pixel level

            'parent.sel.StopSelecting (False)
        End If
        c_zoom = 1 / 16
    End If



    If Not c_UsingPixels Then
        c_zoom = c_zoom / 2
        parent.piczoomtileset.Width = parent.pictileset.Width * c_zoom
        parent.piczoomtileset.Height = parent.pictileset.Height * c_zoom
        With parent
            SetStretchBltMode .piczoomtileset.hdc, HALFTONE
            StretchBlt .piczoomtileset.hdc, 0, 0, .piczoomtileset.Width, .piczoomtileset.Height, .pictileset.hdc, 0, 0, .pictileset.Width, .pictileset.Height, vbSrcCopy
            .piczoomtileset.refresh
        End With
    End If
    parent.currentzoom = c_zoom
    parent.currenttilew = c_zoom * TileW
    'recalculate the scrollbars
    'this will make sure that the tile (or pixel on pixel level)
    'which was click on, will be in center of preview after zoom
    Dim newH As Integer
    Dim newV As Integer
    If Int((TileW * c_zoom)) * tileX - Int(parent.picpreview.Width / 2) < 0 Then
        newH = 0
    ElseIf Int((TileW * c_zoom)) * tileX - Int(parent.picpreview.Width / 2) > parent.hScr.Max Then
        newH = parent.hScr.Max
    Else
        newH = Int((TileW * c_zoom)) * tileX - Int(parent.picpreview.Width / 2)
    End If

    If Int((TileW * c_zoom)) * tileY - Int(parent.picpreview.Height / 2) < 0 Then
        newV = 0
    ElseIf Int((TileW * c_zoom)) * tileY - Int(parent.picpreview.Height / 2) > parent.vScr.Max Then
        newV = parent.vScr.Max
    Else
        newV = Int((TileW * c_zoom)) * tileY - Int(parent.picpreview.Height / 2)
    End If

    'make a correction so the value is always divisible
    'by tilew*zoom or TileW*zoom !
    newH = Int(newH / (TileW * c_zoom)) * (TileW * c_zoom)
    newV = Int(newV / (TileW * c_zoom)) * (TileW * c_zoom)

    Call parent.setScrollBarValues(newH, newV, False)



    parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

ZoomOut_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ZoomOut of Class Module Magnifier"
End Sub

