VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Selection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Dim oldx As Integer
'Dim oldy As Integer
'Dim curdrwwidth As Integer
'Dim curdrwheight As Integer


Dim firstX As Integer
Dim firstY As Integer

'Dim selsourcex As Integer
'Dim selsourcey As Integer

Dim tempboundaries As RECT

Dim dragxcorrection As Integer
Dim dragycorrection As Integer

Enum selectionstate
    notdrawing
    drawing
    append
End Enum

Dim c_selstate As selectionstate

Dim seltilestartx As Integer
Dim seltilestarty As Integer
Dim seltileendx As Integer
Dim seltileendy As Integer

Dim parent As frmMain

Dim undoch As Changes

Dim seltiles() As Integer
Dim isInSelection() As Boolean

Public hasAlreadySelectedParts As Boolean

Dim selectionchanged As Boolean
Dim selectioncancelled As Boolean
Dim selectionmoved As Boolean

Dim boundaries As RECT

Dim totalmoveX As Integer
Dim totalmoveY As Integer


Private Sub Class_Initialize()
    boundaries.Top = 32767
    boundaries.Left = 32767
    boundaries.Right = 0
    boundaries.Bottom = 0
    tempboundaries.Top = 32767
    tempboundaries.Left = 32767
    tempboundaries.Right = 0
    tempboundaries.Bottom = 0

    ReDim seltiles(1024, 1024)
    ReDim isInSelection(1024, 1024)

End Sub

Sub setParent(ByRef main As frmMain)
    Set parent = main
End Sub

Function getIsInSelection(i As Integer, j As Integer) As Boolean
    getIsInSelection = isInSelection(i, j)
End Function

Sub setInSelection(i As Integer, j As Integer)
    isInSelection(i, j) = True
End Sub

Function isEdge(i As Integer, j As Integer) As Boolean
    On Error Resume Next


    If isInSelection(i - 1, j) And isInSelection(i, j - 1) And _
       isInSelection(i + 1, j) And isInSelection(i, j + 1) Then
        isEdge = False
    Else
        isEdge = True
    End If

    On Error GoTo 0
    Exit Function

isEdge_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure isEdge of Class Module Selection"
End Function

Friend Function getBoundaries() As RECT
    getBoundaries = boundaries
End Function

Public Property Get selstate() As selectionstate
    selstate = c_selstate
End Property

Public Property Let selstate(ByVal newselstate As selectionstate)
    c_selstate = newselstate
End Property

Sub MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer

    selectionmoved = False
    selectioncancelled = False
    totalmoveX = 0
    totalmoveY = 0

    'calculate tile coordinates
    On Error GoTo MouseDown_Error

    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))

    firstX = curtilex
    firstY = curtiley

    If curtilex > 1023 Then curtilex = 1023
    If curtilex < 0 Then curtilex = 0
    If curtiley > 1023 Then curtiley = 1023
    If curtiley < 0 Then curtiley = 0

    If selstate = append Then
        'check if we click inside the selection or outside, and with which button
        If Button = vbRightButton Then
            ApplySelection
        ElseIf Button = vbLeftButton Then
            'If isInSelection(curtilex, curtiley) And _
             '    Shift <> 1 And Shift <> 2 Then
            If isInSelection(curtilex, curtiley) And ((parent.pastetype <> p_normal And seltiles(curtilex, curtiley) <> 0) Or parent.pastetype = p_normal) And _
               Shift <> 1 And Shift <> 2 Then
                'we clicked in the selection, ready to move
                dragxcorrection = curtilex
                dragycorrection = curtiley
            ElseIf Shift = 1 Or Shift = 2 Then
                'we want to draw if we clicked outside of selection or
                ' if we use shift or ctrl

                'we want to draw again
                selstate = drawing
                Call initDrawing(x, y)
            Else
                selstate = notdrawing
                ApplySelection
            End If
        End If
    End If

    If selstate = notdrawing And Button = vbLeftButton Then
        'we want to start drawing
        Call initDrawing(x, y)
    End If

    'Check if we tried to cancel selection by right-clicking
    If selstate = drawing And Button = vbRightButton Then
        'Clear selection
        StopSelecting
    End If

    On Error GoTo 0
    Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Selection"
End Sub

Sub StopSelecting()
    Call MouseUp(vbRightButton, 1)
    selstate = append
    selectioncancelled = True
End Sub

Sub MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer

    On Error GoTo MouseMove_Error


    If Button = vbRightButton Then Exit Sub
    selectionmoved = True

    'calculate tile coordinates
    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))

    If curtilex > 1023 Then curtilex = 1023
    If curtilex < 0 Then curtilex = 0
    If curtiley > 1023 Then curtiley = 1023
    If curtiley < 0 Then curtiley = 0

    If hasAlreadySelectedParts And isInSelection(curtilex, curtiley) And ((parent.pastetype <> p_normal And seltiles(curtilex, curtiley) <> 0) Or parent.pastetype = p_normal) And _
       Shift <> 1 And Shift <> 2 Then
        parent.picpreview.MousePointer = 5
    Else

        parent.picpreview.MousePointer = 2
    End If

    If Not SharedVar.MouseDown Then
        Exit Sub
    End If

    If selstate = drawing Then

        'Swap first/current values if needed
        If firstX < curtilex Then
            seltilestartx = firstX
            seltileendx = curtilex
        Else
            seltilestartx = curtilex
            seltileendx = firstX
        End If

        If firstY < curtiley Then
            seltilestarty = firstY
            seltileendy = curtiley
        Else
            seltilestarty = curtiley
            seltileendy = firstY
        End If


        'update the drawing rectangle
        parent.shpdraw.Left = (seltilestartx * parent.currenttilew) - parent.hScr.value
        parent.shpdraw.Top = (seltilestarty * parent.currenttilew) - parent.vScr.value
        parent.shpdraw.Width = (seltileendx - seltilestartx + 1) * parent.currenttilew
        parent.shpdraw.Height = (seltileendy - seltilestarty + 1) * parent.currenttilew

    ElseIf selstate = append Then

        If Button = vbLeftButton Then
            'we are dragging the selection around
            Call Move(curtilex - dragxcorrection, curtiley - dragycorrection)

            dragxcorrection = curtilex
            dragycorrection = curtiley
        End If

    End If

    On Error GoTo 0
    Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module Selection"

End Sub

Sub MouseUp(Button As Integer, Shift As Integer)

    On Error GoTo MouseUp_Error




    If parent.magnifier.UsingPixels Then
        'stupid selection on stupid pixel level has wrong offsets
        'because of the +2, but thats needed in non-pixel level
        'to have the correct tile start
        seltilestartx = (Int((parent.hScr.value + parent.shpdraw.Left) / (parent.currenttilew)))
        seltilestarty = (Int((parent.vScr.value + parent.shpdraw.Top) / (parent.currenttilew)))
        seltileendx = seltilestartx + (parent.shpdraw.Width / (parent.currenttilew)) - 1
        seltileendy = seltilestarty + (parent.shpdraw.Height / (parent.currenttilew)) - 1
    Else
        seltilestartx = (Int((parent.hScr.value + parent.shpdraw.Left + 2) / (parent.currenttilew)))
        seltilestarty = (Int((parent.vScr.value + parent.shpdraw.Top + 2) / (parent.currenttilew)))
        seltileendx = seltilestartx + (parent.shpdraw.Width / (parent.currenttilew)) - 1
        seltileendy = seltilestarty + (parent.shpdraw.Height / (parent.currenttilew)) - 1
    End If

    parent.shpdraw.Visible = False
    parent.shpdraw.Left = 0
    parent.shpdraw.Top = 0
    parent.shpdraw.Width = 1
    parent.shpdraw.Height = 1

    If selectioncancelled Or Not selectionmoved Then Exit Sub

    If Button = vbLeftButton And selstate = drawing Then
        If Shift = 2 Then    'ctrl
            Call RemoveSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
        ElseIf Shift = 1 Then    ' shift
            Call AddSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
        Else
            If hasAlreadySelectedParts Then
                Call AddSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
            Else
                Call ApplySelection
                Call AddSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
            End If
        End If
        selstate = append
    Else
        'We have right-clicked, so we're not adding anything to the selection
    End If

    'If selstate = drawing And hasAlreadySelectedParts Then
    '    selstate = append
    'Else
    '    selstate = NotDrawing
    'End If

    If Not parent.magnifier.UsingPixels Then
        parent.picseltemp.Cls
        Call BitBlt(parent.picseltemp.hdc, totalmoveX, totalmoveY, 1024, 1024, parent.pic1024selection.hdc, 0, 0, vbSrcCopy)
        parent.pic1024selection.Cls
        'parent.picseltemp.refresh
        Call BitBlt(parent.pic1024selection.hdc, 0, 0, 1024, 1024, parent.picseltemp.hdc, 0, 0, vbSrcCopy)
        'parent.pic1024selection.refresh
    End If

    parent.UpdatePreview

    On Error GoTo 0
    Exit Sub

MouseUp_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseUp of Class Module Selection"

End Sub

Sub initDrawing(x As Single, y As Single)
    Dim curtilex
    Dim curtiley


    On Error GoTo initDrawing_Error

    c_selstate = drawing

    'determine starting point of the selection
    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))


    parent.shpdraw.Left = (curtilex * parent.currenttilew) - parent.hScr.value
    parent.shpdraw.Top = (curtiley * parent.currenttilew) - parent.vScr.value
    parent.shpdraw.Width = 1
    parent.shpdraw.Height = 1
    parent.shpdraw.Visible = True

    On Error GoTo 0
    Exit Sub

initDrawing_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure initDrawing of Class Module Selection"

End Sub

Function areThereTilesInSelection()
    Dim i As Integer
    Dim j As Integer
    For j = 0 To 1023
        For i = 0 To 1023
            If isInSelection(i, j) Then
                areThereTilesInSelection = True
                Exit Function
            End If
        Next
    Next
    areThereTilesInSelection = False
End Function

Sub AddSelectionArea(seltilestartx As Integer, seltileendx As Integer, seltilestarty As Integer, seltileendy As Integer, Optional refresh As Boolean = True)
    Dim i As Integer
    Dim j As Integer

    On Error GoTo AddSelectionArea_Error

    Dim hasAdded As Boolean
    hasAdded = False

    If hasAlreadySelectedParts = False Then
        parent.undoredo.ResetRedo
        Set undoch = New Changes
    End If

    If boundaries.Left > seltilestartx Then boundaries.Left = seltilestartx
    If boundaries.Right < seltileendx Then boundaries.Right = seltileendx
    If boundaries.Top > seltilestarty Then boundaries.Top = seltilestarty
    If boundaries.Bottom < seltileendy Then boundaries.Bottom = seltileendy
    tempboundaries = boundaries

    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If Not isInSelection(i, j) Then
                If isTileSpecial(parent, i, j) Then
                    'special tile found, add it completly
                    Call AddObjectSelectionArea(i, j)

                    If tempboundaries.Left < boundaries.Left Then boundaries.Left = tempboundaries.Left
                    If tempboundaries.Right > boundaries.Right Then boundaries.Right = tempboundaries.Right
                    If tempboundaries.Top < boundaries.Top Then boundaries.Top = tempboundaries.Top
                    If tempboundaries.Bottom > boundaries.Bottom Then boundaries.Bottom = tempboundaries.Bottom

                Else
                    If parent.getTile(i, j) <> 0 Then
                        'copy all the tiles to the selection array
                        Call setSelTile(i, j, parent.getTile(i, j))
                        'remove the tiles from the level
                        Call parent.setTile(i, j, 0, undoch, True)
                        Call parent.UpdateLevelTile(i, j, False, False)
                    End If
                    'flag that they are on the selection
                    isInSelection(i, j) = True
                End If
                hasAdded = True
            End If
        Next
    Next


    hasAlreadySelectedParts = True

    If refresh Then
        parent.pic1024selection.refresh
        frmGeneral.UpdateToolbarButtons
        parent.UpdateLevel
    End If

    On Error GoTo 0
    Exit Sub

AddSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure AddSelectionArea of Class Module Selection"
End Sub

Sub RemoveSelectionArea(seltilestartx As Integer, seltileendx As Integer, seltilestarty As Integer, seltileendy As Integer, Optional refresh As Boolean = True)
    Dim i As Integer
    Dim j As Integer
    
    Dim foundtiles As Boolean

    On Error GoTo RemoveSelectionArea_Error

    tempboundaries = boundaries
    foundtiles = False

    'check for special objects being removed

    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If isInSelection(i, j) Then
                If isSelTileSpecial(Me, i, j) Then
                    'special tile found, removing it completly
                    Call RemoveObjectSelectionArea(i, j)

                Else
                    Call parent.setTile(i, j, seltiles(i, j), undoch, True)
                    Call parent.UpdateLevelTile(i, j, False)
                    'remove the tiles from the selection
                    Call setSelTile(i, j, 0, False)
                    'flag that they are on the selection
                    isInSelection(i, j) = False
                End If
            End If
        Next
    Next

    frmGeneral.pictemp.BackColor = vbWhite
    frmGeneral.pictemp.Width = seltileendx - seltilestartx + 1
    frmGeneral.pictemp.Height = seltileendy - seltilestarty + 1
    BitBlt parent.pic1024selection.hdc, seltilestartx, seltilestarty, seltileendx - seltilestartx + 1, seltileendy - seltilestarty + 1, frmGeneral.pictemp.hdc, 0, 0, vbSrcCopy
    frmGeneral.pictemp.BackColor = vbBlack



    ' check if we need to shrink the left side
    'If seltilestartx <= tempboundaries.Left Then
    j = 0: i = 0
    For j = tempboundaries.Left To boundaries.Right
        For i = 0 To 1023
            If isInSelection(j, i) Then
                foundtiles = True
                GoTo skipleft
            End If
        Next
        tempboundaries.Left = tempboundaries.Left + 1
    Next
    'End If
skipleft:

    ' check if we need to shrink the top side
    'If seltilestarty <= tempboundaries.Top Then
    j = 0: i = 0
    For j = tempboundaries.Top To boundaries.Bottom
        For i = 0 To 1023
            If isInSelection(i, j) Then
                foundtiles = True
                GoTo skiptop
            End If
        Next
        tempboundaries.Top = tempboundaries.Top + 1
    Next
    'End If
skiptop:

    ' check if we need to shrink the right side
    'If seltileendx >= tempboundaries.Right Then
    j = 0: i = 0
    For j = tempboundaries.Right To boundaries.Left Step -1
        For i = 0 To 1023
            If isInSelection(j, i) Then
                foundtiles = True
                GoTo skipright
            End If
        Next
        tempboundaries.Right = tempboundaries.Right - 1
    Next
    'End If
skipright:

    ' check if we need to shrink the right side
    'If seltileendy >= tempboundaries.Bottom Then
    j = 0: i = 0
    For j = tempboundaries.Bottom To boundaries.Top Step -1
        For i = 0 To 1023
            If isInSelection(i, j) Then
                foundtiles = True
                GoTo skipbottom
            End If
        Next
        tempboundaries.Bottom = tempboundaries.Bottom - 1
    Next
    'End If
skipbottom:

    boundaries = tempboundaries

    If refresh Then
        'check if there are any tiles left in selection
        hasAlreadySelectedParts = foundtiles
        If Not hasAlreadySelectedParts Then
            parent.pic1024selection.Cls
        End If

        frmGeneral.UpdateToolbarButtons
        parent.UpdateLevel
    End If

    On Error GoTo 0
    Exit Sub

RemoveSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure RemoveSelectionArea of Class Module Selection"
End Sub



Sub ApplySelection()

    On Error GoTo ApplySelection_Error

    'apply selection is nothing more than removeselection but on the whole selection
    'array, rather than a part of it

    Dim i As Integer
    Dim j As Integer



    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            If isInSelection(i, j) And (selectionchanged Or seltiles(i, j) <> 0) Then
                'copy all the tiles to the level array

                'check for draw type
                If Not seltiles(i, j) = -1 And _
                   ((parent.pastetype = p_normal) Or _
                    (parent.pastetype = p_trans And seltiles(i, j) <> 0) Or _
                    (parent.pastetype = p_under And parent.getTile(i, j) = 0 And AreaClearForObject(parent, i, j, seltiles(i, j)))) Then
                    If isSelTileSpecial(Me, i, j) Then
                        Call setObject(parent, seltiles(i, j), i, j, undoch, True)
                    Else
                        Call parent.setTile(i, j, seltiles(i, j), undoch, True)
                        Call parent.UpdateLevelTile(i, j, False)
                    End If
                End If
            End If
        Next
    Next

    hasAlreadySelectedParts = False
    parent.pic1024selection.Cls

    'Call parent.UpdateLevel

    'reset selection state
    c_selstate = notdrawing
    selectionchanged = False

    boundaries.Top = 32767
    boundaries.Left = 32767
    boundaries.Right = 0
    boundaries.Bottom = 0


    'clear possible tile nr's stored in unused selection tiles
    Call DeleteSelection

    Call parent.undoredo.AddToUndo(undoch)


    On Error GoTo 0
    Exit Sub

ApplySelection_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ApplySelection of Class Module Selection"

End Sub

Sub CopySelection()
'set the array into the clipboard array
    Call parent.clip.SetClipboardData(seltiles, isInSelection, boundaries)

End Sub

Sub CutSelection()
'set the array into the clipboard array
'remove the selection
    CopySelection
    DeleteSelection
End Sub

Sub DeleteSelection()
'clear the selection, but don't copy the tiles from the selection to the level
    Erase isInSelection
    Erase seltiles
    ReDim isInSelection(1024, 1024)
    ReDim seltiles(1024, 1024)

    frmGeneral.UpdateToolbarButtons

    parent.UpdateLevel

End Sub

Sub DrawCornerLinesOn(i As Integer, j As Integer, lbx As Integer, lby As Integer)
    Dim x As Integer
    Dim y As Integer

    On Error GoTo DrawCornerLinesOn_Error

    On Error Resume Next

    If parent.pastetype <> p_normal And seltiles(i, j) = 0 Then
        Exit Sub
    End If

    x = (i - lbx) * (parent.currenttilew)
    y = (j - lby) * (parent.currenttilew)

    If Not isInSelection(i - 1, j) Or (parent.pastetype <> p_normal And seltiles(i - 1, j) = 0) Then
        'tile left of it is not in selection
        parent.piclevel.Line (x, y)-(x, y + (parent.currenttilew))
    End If
    If Not isInSelection(i, j - 1) Or (parent.pastetype <> p_normal And seltiles(i, j - 1) = 0) Then
        'tile top of it is not in selection
        parent.piclevel.Line (x, y)-(x + (parent.currenttilew), y)
    End If
    If Not isInSelection(i + 1, j) Or (parent.pastetype <> p_normal And seltiles(i + 1, j) = 0) Then
        'tile right of it is not in selection
        parent.piclevel.Line (x + (parent.currenttilew) - 1, y)-(x + (parent.currenttilew) - 1, y + (parent.currenttilew))
    End If
    If Not isInSelection(i, j + 1) Or (parent.pastetype <> p_normal And seltiles(i, j + 1) = 0) Then
        'tile bottom of it is not in selection
        parent.piclevel.Line (x, y + (parent.currenttilew) - 1)-(x + (parent.currenttilew), y + (parent.currenttilew) - 1)
    End If

    On Error GoTo 0
    Exit Sub

DrawCornerLinesOn_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawCornerLinesOn of Class Module Selection"
End Sub



Friend Sub SetSelectionData(tiles() As Integer, bitfield() As Boolean, ByRef Bounds As RECT)
    On Error GoTo SetSelectionData_Error

    If hasAlreadySelectedParts Then
        ApplySelection
    Else
        parent.undoredo.ResetRedo
        Set undoch = New Changes
    End If

    seltiles = tiles
    isInSelection = bitfield
    boundaries = Bounds

    hasAlreadySelectedParts = True
    selstate = append

    parent.pic1024selection.Cls
    Dim i As Integer
    Dim j As Integer
    For j = 0 To 1023
        For i = 0 To 1023
            If isInSelection(i, j) Then
                Call SetPixel(parent.pic1024selection.hdc, i, j, TilePixelColor(seltiles(i, j)))
            End If
        Next
    Next
    parent.pic1024selection.refresh

    'move the selection boundaries to the top left of the picpreview,
    'but if a part will be cut off then move it until no parts are being cut off
    Dim lbx As Integer    'lowestval for x
    Dim hbx As Integer    'highestval for x
    Dim lby As Integer    'lowestval for y
    Dim hby As Integer    'highestval for y
    lbx = Int(parent.hScr.value / (parent.currenttilew))
    hbx = Int((parent.hScr.value + parent.picpreview.Width) / (parent.currenttilew))
    lby = Int(parent.vScr.value / (parent.currenttilew))
    hby = Int((parent.vScr.value + parent.picpreview.Height) / (parent.currenttilew))

    Dim dx As Integer
    dx = lbx - boundaries.Left
    If (boundaries.Right + dx) > 1023 Then
        dx = dx - ((boundaries.Right + dx) - 1024)
    End If

    Dim dY As Integer
    dY = lby - boundaries.Top
    If (boundaries.Bottom + dY) > 1023 Then
        dY = dY - ((boundaries.Bottom + dY) - 1024)
    End If
    Call Move(dx, dY, False)

    parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

SetSelectionData_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure SetSelectionData of Class Module Selection"
End Sub

Sub Move(dx As Integer, dY As Integer, Optional refresh As Boolean = True)
    On Error GoTo Move_Error

    If dx = 0 And dY = 0 Then
        'no move
        Exit Sub
    End If

    totalmoveX = totalmoveX + dx
    totalmoveY = totalmoveY + dY

    If boundaries.Left + dx < 0 Then dx = 0 - boundaries.Left
    If boundaries.Right + dx > 1023 Then dx = 1023 - boundaries.Right
    If boundaries.Top + dx < 0 Then dY = 0 - boundaries.Top
    If boundaries.Bottom + dx > 1023 Then dY = 1023 - boundaries.Bottom

    If boundaries.Left + dx < 0 Or boundaries.Top + dY < 0 Or _
       boundaries.Right + dx > 1023 Or boundaries.Bottom + dY > 1023 Then
        Exit Sub
    End If

    Dim newseltiles(1024, 1024) As Integer
    Dim newisInSelection(1024, 1024) As Boolean

    Dim i As Integer
    Dim j As Integer
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            If isInSelection(i, j) Then
                newseltiles(i + dx, j + dY) = seltiles(i, j)
                newisInSelection(i + dx, j + dY) = True
            End If
        Next
    Next
    boundaries.Left = boundaries.Left + dx
    boundaries.Top = boundaries.Top + dY
    boundaries.Right = boundaries.Right + dx
    boundaries.Bottom = boundaries.Bottom + dY

    'apply the new array to the old one
    seltiles = newseltiles
    isInSelection = newisInSelection

    'don't update pic1024selection if not on pixel level, it slows down alot
    If parent.magnifier.UsingPixels Then
        parent.picseltemp.Cls
        Call BitBlt(parent.picseltemp.hdc, dx, dY, 1024, 1024, parent.pic1024selection.hdc, 0, 0, vbSrcCopy)
        parent.pic1024selection.Cls
        'parent.picseltemp.refresh
        Call BitBlt(parent.pic1024selection.hdc, 0, 0, 1024, 1024, parent.picseltemp.hdc, 0, 0, vbSrcCopy)
        'parent.pic1024selection.refresh
    End If

    'remember that the selection has been moved
    selectionchanged = True

    If refresh Then Call parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

Move_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Move of Class Module Selection"
End Sub

Sub setSelTile(i As Integer, j As Integer, val As Integer, Optional DrawPixel As Boolean = True)
    seltiles(i, j) = val
    '   isInSelection(i, j) = True
    If DrawPixel Then
        Call SetPixel(parent.pic1024selection.hdc, i, j, TilePixelColor(val))
    End If
End Sub

Function getSelTile(i As Integer, j As Integer) As Integer
    getSelTile = seltiles(i, j)
End Function

Sub SwitchOrReplace(src As Integer, dest As Integer, replace As Boolean)
'for each isinselection(i,j) between the boundaries replace or switch
    Dim i As Integer
    Dim j As Integer
    Dim m As Long
    Dim n As Long
    On Error GoTo SwitchOrReplace_Error

    n = 0
    m = 0

    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            If isInSelection(i, j) Then
                If seltiles(i, j) = src Then
                    Call setSelTile(i, j, dest)
                    n = n + 1
                ElseIf seltiles(i, j) = dest And Not replace Then
                    Call setSelTile(i, j, src)
                    m = m + 1
                End If
            End If
        Next
    Next

    If replace Then
        MsgBox n & " tiles replaced.", vbOKOnly + vbInformation, "Tiles replaced"
    Else
        MsgBox n & " tiles A -> B" & vbCrLf & m & " tiles A <- B", vbOKOnly + vbInformation, "Tiles switched"
    End If

    parent.UpdateLevel

    selectionchanged = True

    On Error GoTo 0
    Exit Sub

SwitchOrReplace_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure SwitchOrReplace of Class Module Selection"
End Sub

Sub Mirror()
'mirror entire selection array

    Dim i As Integer
    Dim j As Integer

    Dim tmp As Integer
    Dim tmpisin As Boolean

    On Error GoTo Mirror_Error

    parent.undoredo.ResetRedo
    Set undoch = New Changes

    Dim tmpobjects() As Integer
    ReDim tmpobjects(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    'first off, calculate the new positions of any objects
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            tmp = seltiles(i, j)

            If tmp = 217 Or tmp = 219 Or tmp = 220 Then
                tmpobjects(boundaries.Left + boundaries.Right - (i + GetMaxSizeOfObject(tmp)), j) = tmp
                Call DestroySelObject(Me, i, j)
            End If
        Next
    Next

    'flip the selection array
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To Int(boundaries.Right - ((boundaries.Right - boundaries.Left) / 2))

            tmp = seltiles(i, j)
            tmpisin = isInSelection(i, j)

            isInSelection(i, j) = isInSelection(boundaries.Right - (i - boundaries.Left), j)
            isInSelection(boundaries.Right - (i - boundaries.Left), j) = tmpisin

            'ignore special objects
            Call setSelTile(i, j, seltiles(boundaries.Right - (i - boundaries.Left), j))
            Call setSelTile(boundaries.Right - (i - boundaries.Left), j, tmp)

        Next
    Next

    'now that it's flipped we restore the objects
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    Call parent.undoredo.AddToUndo(undoch)

    selectionchanged = True

    Call parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

Mirror_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Mirror of Class Module Selection"

End Sub

Sub Flip()
'mirror entire selection array

    Dim i As Integer
    Dim j As Integer

    Dim tmp As Integer
    Dim tmpisin As Boolean

    On Error GoTo Flip_Error

    Dim tmpobjects() As Integer
    ReDim tmpobjects(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    'first off, calculate the new positions of any objects
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            tmp = seltiles(i, j)

            If tmp = 217 Or tmp = 219 Or tmp = 220 Then
                tmpobjects(i, boundaries.Top + boundaries.Bottom - (j + GetMaxSizeOfObject(tmp))) = tmp
                Call DestroySelObject(Me, i, j)
            End If
        Next
    Next

    'flip the selection array
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To Int(boundaries.Bottom - ((boundaries.Bottom - boundaries.Top) / 2))

            tmp = seltiles(i, j)
            tmpisin = isInSelection(i, j)

            isInSelection(i, j) = isInSelection(i, boundaries.Bottom - (j - boundaries.Top))
            isInSelection(i, boundaries.Bottom - (j - boundaries.Top)) = tmpisin

            'ignore special objects
            Call setSelTile(i, j, seltiles(i, boundaries.Bottom - (j - boundaries.Top)))
            Call setSelTile(i, boundaries.Bottom - (j - boundaries.Top), tmp)
        Next
    Next

    'now that it's flipped we restore the objects
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    selectionchanged = True

    Call parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

Flip_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Flip of Class Module Selection"
End Sub

'etc etc

Sub RotateCW()
    Dim i As Integer
    Dim j As Integer

    Dim selctrx As Integer
    Dim selctry As Integer
    Dim newboundaries As RECT

    Dim tmp As Integer


    'New parameters of selection
    selctrx = Int((boundaries.Right - boundaries.Left) / 2)
    selctry = Int((boundaries.Bottom - boundaries.Top) / 2)
    newboundaries.Left = (selctrx + boundaries.Left) - (selctry)
    newboundaries.Top = (selctry + boundaries.Top) - (selctrx)
    newboundaries.Bottom = newboundaries.Top + (boundaries.Right - boundaries.Left)
    newboundaries.Right = newboundaries.Left + (boundaries.Bottom - boundaries.Top)

    Dim tmptile() As Integer
    Erase tmptile
    ReDim tmptile(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpisin() As Boolean
    Erase tmpisin
    ReDim tmpisin(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpobjects() As Integer
    Erase tmpobjects
    ReDim tmpobjects(newboundaries.Left To newboundaries.Right, newboundaries.Top To newboundaries.Bottom)

    'Make sure new parameters aren't out of bounds
    If newboundaries.Left < 0 Then
        newboundaries.Left = 0
        newboundaries.Right = newboundaries.Left + (boundaries.Bottom - boundaries.Top)
    ElseIf newboundaries.Right > 1023 Then
        newboundaries.Left = newboundaries.Left + (1023 - newboundaries.Right)
        newboundaries.Right = 1023
    End If

    If newboundaries.Top < 0 Then
        newboundaries.Top = 0
        newboundaries.Bottom = newboundaries.Top + (boundaries.Right - boundaries.Left)
    ElseIf newboundaries.Bottom > 1023 Then
        newboundaries.Top = newboundaries.Top + (1023 - newboundaries.Bottom)
        newboundaries.Bottom = 1023
    End If

    'first off, calculate the new positions of any objects
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To boundaries.Bottom
            tmp = seltiles(i, j)
            tmpisin(i, j) = isInSelection(i, j)
            If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then

                '''Special tile found, calculating new coordinates
                tmpobjects(newboundaries.Right - ((j - boundaries.Top) + GetMaxSizeOfObject(tmp)), newboundaries.Top + (i - boundaries.Left)) = tmp
                Call SearchAndDestroySelObject(Me, i, j)
            Else

                '''Store tile in current selection
                tmptile(i, j) = seltiles(i, j)
            End If

            'Clean that tile off the selection
            isInSelection(i, j) = False
            Call setSelTile(i, j, 0)
        Next
    Next



    'Retile the new selection with corresponding tiles
    For j = newboundaries.Top To newboundaries.Bottom
        For i = newboundaries.Left To newboundaries.Right
            isInSelection(i, j) = tmpisin(boundaries.Left + (j - newboundaries.Top), boundaries.Top + (newboundaries.Right - i))
            If tmptile(boundaries.Left + (j - newboundaries.Top), boundaries.Top + (newboundaries.Right - i)) <> -1 Then
                Call setSelTile(i, j, tmptile(boundaries.Left + (j - newboundaries.Top), boundaries.Top + (newboundaries.Right - i)))
            End If

        Next
    Next

    'now that it's flipped we restore the objects
    For j = newboundaries.Top To newboundaries.Bottom
        For i = newboundaries.Left To newboundaries.Right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    'Redefine selection with new parameters
    boundaries.Left = newboundaries.Left
    boundaries.Top = newboundaries.Top
    boundaries.Right = newboundaries.Right
    boundaries.Bottom = newboundaries.Bottom


    selectionchanged = True

    Call parent.UpdateLevel
End Sub

Sub RotateCCW()
    Dim i As Integer
    Dim j As Integer

    Dim selctrx As Integer
    Dim selctry As Integer

    Dim newboundaries As RECT

    Dim tmp As Integer

    'New parameters of selection
    selctrx = Int((boundaries.Right - boundaries.Left) / 2)
    selctry = Int((boundaries.Bottom - boundaries.Top) / 2)
    newboundaries.Left = (selctrx - (selctry - boundaries.Left))
    newboundaries.Top = (selctry - (selctrx - boundaries.Top))

    newboundaries.Right = newboundaries.Left + (boundaries.Bottom - boundaries.Top)
    newboundaries.Bottom = newboundaries.Top + (boundaries.Right - boundaries.Left)

    Dim tmptile() As Integer
    Erase tmptile
    ReDim tmptile(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpisin() As Boolean
    Erase tmpisin
    ReDim tmpisin(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpobjects() As Integer
    Erase tmpobjects
    ReDim tmpobjects(newboundaries.Left To newboundaries.Right, newboundaries.Top To newboundaries.Bottom)


    'Make sure new parameters aren't out of bounds
    If newboundaries.Left < 0 Then
        newboundaries.Left = 0
        newboundaries.Right = newboundaries.Left + (boundaries.Bottom - boundaries.Top)
    ElseIf newboundaries.Right > 1023 Then
        newboundaries.Left = newboundaries.Left + (1023 - newboundaries.Right)
        newboundaries.Right = 1023
    End If

    If newboundaries.Top < 0 Then
        newboundaries.Top = 0
        newboundaries.Bottom = newboundaries.Top + (boundaries.Right - boundaries.Left)
    ElseIf newboundaries.Bottom > 1023 Then
        newboundaries.Top = newboundaries.Top + (1023 - newboundaries.Bottom)
        newboundaries.Bottom = 1023
    End If



    'first off, calculate the new positions of any objects
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To boundaries.Bottom
            tmp = seltiles(i, j)
            tmpisin(i, j) = isInSelection(i, j)
            If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then

                '''Special tile found, calculating new coordinates
                tmpobjects(newboundaries.Left + (j - boundaries.Top), newboundaries.Bottom - ((i - boundaries.Left) + GetMaxSizeOfObject(tmp))) = tmp
                Call SearchAndDestroySelObject(Me, i, j)
            Else

                '''Store tile in current selection
                tmptile(i, j) = seltiles(i, j)
            End If

            'Clean that tile off the selection
            isInSelection(i, j) = False
            Call setSelTile(i, j, 0)
        Next
    Next

    'Retile the new selection with corresponding tiles
    For j = newboundaries.Top To newboundaries.Bottom
        For i = newboundaries.Left To newboundaries.Right
            If tmptile(boundaries.Left + (newboundaries.Bottom - j), boundaries.Top + (i - newboundaries.Left)) <> -1 Then
                Call setSelTile(i, j, tmptile(boundaries.Left + (newboundaries.Bottom - j), boundaries.Top + (i - newboundaries.Left)))
            End If
            isInSelection(i, j) = tmpisin(boundaries.Left + (newboundaries.Bottom - j), boundaries.Top + (i - newboundaries.Left))
        Next
    Next

    'now that it's flipped we restore the objects
    For j = newboundaries.Top To newboundaries.Bottom
        For i = newboundaries.Left To newboundaries.Right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next


    'Redefine selection with new parameters
    boundaries.Left = newboundaries.Left
    boundaries.Top = newboundaries.Top
    boundaries.Right = newboundaries.Right
    boundaries.Bottom = newboundaries.Bottom



    selectionchanged = True
    Call parent.UpdateLevel
End Sub

Sub Rotate180()
    Dim i As Integer
    Dim j As Integer
    Dim tmp As Integer

    Dim tmptile() As Integer
    Erase tmptile
    ReDim tmptile(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpisin() As Boolean
    Erase tmpisin
    ReDim tmpisin(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpobjects() As Integer
    Erase tmpobjects
    ReDim tmpobjects(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    'first off, calculate the new positions of any objects
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To boundaries.Bottom
            tmp = seltiles(i, j)
            tmpisin(i, j) = isInSelection(i, j)
            If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then
                tmpobjects(boundaries.Left + boundaries.Right - (i + GetMaxSizeOfObject(tmp)), boundaries.Top + boundaries.Bottom - (j + GetMaxSizeOfObject(tmp))) = tmp
                Call SearchAndDestroySelObject(Me, i, j)
            Else

                'Store tile
                tmptile(i, j) = seltiles(i, j)
            End If
        Next
    Next

    'now that the objects are temp gone we can flip the image
    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            Call setSelTile(i, j, tmptile(boundaries.Right - (i - boundaries.Left), boundaries.Bottom - (j - boundaries.Top)))
            isInSelection(i, j) = tmpisin(boundaries.Right - (i - boundaries.Left), boundaries.Bottom - (j - boundaries.Top))
        Next
    Next

    'now that it's flipped we restore the objects
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To boundaries.Bottom
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    selectionchanged = True

    Call parent.UpdateLevel

End Sub

Sub RotateFree(angle As Double)
      
    Dim i As Integer
    Dim j As Integer
    
    Dim m As Single
    Dim n As Single
    
    Dim tmp As Integer

    Dim tmpdestx As Integer
    Dim tmpdesty As Integer
    Dim tmporigx As Integer
    Dim tmporigy As Integer
    Dim tmporigxsng As Single
    Dim tmporigysng As Single
    
    Dim tmptile(1023, 1023) As Integer
    'Erase tmptile
    'ReDim tmptile(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpisin(1023, 1023) As Boolean
    'Erase tmpisin
    'ReDim tmpisin(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    Dim tmpobjects() As Integer
    ReDim tmpobjects(boundaries.Left To boundaries.Right, boundaries.Top To boundaries.Bottom)

    'first off, calculate the new positions of any objects
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To boundaries.Bottom
            tmp = seltiles(i, j)
            tmpisin(i, j) = isInSelection(i, j)
            If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then
'                tmpobjects(Int(Cos(angle) * i + Sin(angle) * j), Int(-Sin(angle) * i + Cos(angle) * j)) = tmp
                Call SearchAndDestroySelObject(Me, i, j)
            Else
                'Store tile
                tmptile(i, j) = seltiles(i, j)
            End If
            isInSelection(i, j) = False
            seltiles(i, j) = 0
        Next
    Next

    'now that the objects are temp gone we can flip the image
'    For j = boundaries.Top To boundaries.Bottom
'        For i = boundaries.Left To boundaries.Right
'            tmpdestx = Int(Cos(angle) * i + Sin(angle) * j)
'            tmpdesty = Int(-Sin(angle) * i + Cos(angle) * j)
'            Call setSelTile(tmpdestx, tmpdesty, tmptile(i, j))
'            isInSelection(tmpdestx, tmpdesty) = tmpisin(i, j)
'        Next
'    Next

tempboundaries = boundaries

tmporigy = boundaries.Top
tmporigysng = boundaries.Top
    
    Dim cosangle As Double
    Dim sinangle As Double
    cosangle = Cos(angle)
    sinangle = Sin(angle)
    
    
    For n = -(boundaries.Bottom - boundaries.Top) \ 2 To (boundaries.Bottom - boundaries.Top + 0.5) \ 2 Step 0.25
        tmporigx = boundaries.Left
        tmporigxsng = boundaries.Left
        For m = -(boundaries.Right - boundaries.Left) \ 2 To (boundaries.Right - boundaries.Left + 0.5) \ 2 Step 0.25
            tmpdestx = Int(cosangle * m + sinangle * n) + boundaries.Left + (boundaries.Right - boundaries.Left) \ 2
            tmpdesty = Int(-sinangle * m + cosangle * n) + boundaries.Top + (boundaries.Bottom - boundaries.Top) \ 2
            
            Call setSelTile(tmpdestx, tmpdesty, tmptile(tmporigx, tmporigy))
            isInSelection(tmpdestx, tmpdesty) = tmpisin(tmporigx, tmporigy)
                        
            If tmpisin(tmporigx, tmporigy) Then
                If tmpdestx < tempboundaries.Left Then tempboundaries.Left = tmpdestx
                If tmpdestx > tempboundaries.Right Then tempboundaries.Right = tmpdestx
                If tmpdesty < tempboundaries.Top Then tempboundaries.Top = tmpdesty
                If tmpdesty > tempboundaries.Bottom Then tempboundaries.Bottom = tmpdesty
            End If
            
            tmporigxsng = tmporigxsng + 0.25
            tmporigx = Int(tmporigxsng)
        Next
        tmporigysng = tmporigysng + 0.25
        tmporigy = Int(tmporigysng)
    Next
    
    'now that it's flipped we restore the objects
    For i = boundaries.Left To boundaries.Right
        For j = boundaries.Top To boundaries.Bottom
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    boundaries = tempboundaries
    
    selectionchanged = True

    Call parent.UpdateLevel
    
End Sub


Sub TexTToMap(text() As Integer, Width As Integer, Height As Integer)
    Dim bnds As RECT
    Dim selectiontiles() As Integer
    Dim bitfield() As Boolean
    On Error GoTo TexTToMap_Error

    ReDim selectiontiles(1024, 1024)
    ReDim bitfield(1024, 1024)

    bnds.Left = 0
    bnds.Top = 0
    bnds.Right = Width - 1
    bnds.Bottom = Height - 1

    Dim i As Integer
    Dim j As Integer
    For j = 0 To Height - 1
        For i = 0 To Width - 1
            selectiontiles(i, j) = text(i, j)
            bitfield(i, j) = True
        Next
    Next

    Call SetSelectionData(selectiontiles, bitfield, bnds)

    On Error GoTo 0
    Exit Sub

TexTToMap_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure TexTToMap of Class Module Selection"
End Sub

Sub PicToMap(pic() As Integer, Width As Integer, Height As Integer)
    Call TexTToMap(pic(), Width, Height)
End Sub

Sub RemoveObjectSelectionArea(x As Integer, y As Integer)
    Dim i As Integer
    Dim j As Integer
    Dim coord() As Integer
    Dim coordX As Integer
    Dim coordY As Integer
    Dim size As Integer

    On Error GoTo RemoveObjectSelectionArea_Error

    ReDim coord(1) As Integer
    coord = SearchSelObject(Me, x, y)
    coordX = coord(0)
    coordY = coord(1)
    size = GetMaxSizeOfObject(seltiles(coordX, coordY))

    For j = coordY To coordY + size
        For i = coordX To coordX + size
            If isInSelection(i, j) Then
                'copy all the tiles to the level array
                Call parent.setTile(i, j, seltiles(i, j), undoch, True)
                Call parent.UpdateLevelTile(i, j, False)
                'remove the tiles from the selection
                Call setSelTile(i, j, 0, False)
                'flag that they are on the selection
                isInSelection(i, j) = False
                Call SetPixel(parent.pic1024selection.hdc, i, j, vbWhite)
            End If
        Next
    Next

    parent.mapchanged = True
    On Error GoTo 0
    Exit Sub

RemoveObjectSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure RemoveObjectSelectionArea of Class Module Selection"

End Sub
Sub AddObjectSelectionArea(x As Integer, y As Integer)
    Dim i As Integer
    Dim j As Integer
    Dim coord() As Integer
    Dim coordX As Integer
    Dim coordY As Integer
    Dim size As Integer

    On Error GoTo AddObjectSelectionArea_Error

    ReDim coord(1) As Integer
    coord = SearchObject(parent, x, y)
    coordX = coord(0)
    coordY = coord(1)
    size = GetMaxSizeOfObject(parent.getTile(coordX, coordY))

    For j = coordY To coordY + size
        For i = coordX To coordX + size
            Call setSelTile(i, j, parent.getTile(i, j))
            'remove the tiles from the level
            Call parent.setTile(i, j, 0, undoch, True)
            Call parent.UpdateLevelTile(i, j, False)
            'flag that they are on the selection
            isInSelection(i, j) = True
        Next
    Next

    'Store coordinates to adjust boundaries if needed
    tempboundaries.Left = coordX
    tempboundaries.Right = coordX + size
    tempboundaries.Top = coordY
    tempboundaries.Bottom = coordY + size

    parent.mapchanged = True
    On Error GoTo 0
    Exit Sub

AddObjectSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure AddObjectSelectionArea of Class Module Selection"

End Sub

Sub Resize(Left As Integer, Top As Integer, Right As Integer, Bottom As Integer)
'first move selection to left and top, then resize
    Call Move(-boundaries.Left + Left, -boundaries.Top + Top, False)

    Dim newselection(1024, 1024) As Integer
    Dim newbitfield(1024, 1024) As Boolean

    'get nrOfLinesOnX
    Dim nrOfLinesOnX As Integer
    nrOfLinesOnX = Round(((Bottom - Top) - (boundaries.Bottom - boundaries.Top)))
    Dim shrink As Boolean
    If nrOfLinesOnX < 0 Then
        shrink = True
        nrOfLinesOnX = Abs(nrOfLinesOnX)
    Else
        shrink = False
    End If

    Dim oldlinecount As Integer
    oldlinecount = 0

    Dim i As Integer
    Dim j As Integer
    For j = Top To Bottom
        If (j - Top) Mod Round((Bottom - Top) / nrOfLinesOnX) = 0 And j <> Top And j <> Bottom Then
            'we need to add/remove a line
            'check which of lines previous and next has the most
            '0 tiles
            Dim prevnr As Integer
            prevnr = TileCountOnLine(boundaries.Top + oldlinecount - 1, 0, False, boundaries)
            Dim nextnr As Integer
            nextnr = TileCountOnLine(boundaries.Top + oldlinecount, 0, False, boundaries)
            Dim curline As Integer
            Dim nextnextnr As Integer
            nextnextnr = TileCountOnLine(boundaries.Top + oldlinecount + 1, 0, False, boundaries)

            If shrink Then
                'skip the line
                oldlinecount = oldlinecount + 1

                'check which line to use
                If prevnr <= nextnr And prevnr <> 0 Then    'And boundaries.top + oldlinecount - 1 <= boundaries.bottom Then
                    curline = oldlinecount - 1
                Else
                    curline = oldlinecount
                End If

                'draw the line
                i = boundaries.Left
                For i = boundaries.Left To boundaries.Right
                    If isInSelection(i, boundaries.Top + curline) Then
                        newselection(i, j) = seltiles(i, boundaries.Top + curline)
                        newbitfield(i, j) = True
                    End If
                Next
                oldlinecount = oldlinecount + 1
            Else
                'check which line to use
                If prevnr >= nextnr And prevnr <> 0 Then    'And boundaries.top + oldlinecount - 1 <= boundaries.bottom Then
                    If prevnr >= nextnextnr Then
                        curline = oldlinecount - 1
                    Else
                        curline = oldlinecount + 1
                    End If
                Else
                    If nextnr >= nextnextnr Then
                        curline = oldlinecount
                    Else
                        curline = oldlinecount + 1
                    End If
                End If

                'draw line
                i = boundaries.Left
                For i = boundaries.Left To boundaries.Right
                    If isInSelection(i, boundaries.Top + curline) Then
                        newselection(i, j) = seltiles(i, boundaries.Top + curline)
                        newbitfield(i, j) = True
                    End If
                Next
            End If
        Else
            i = boundaries.Left
            For i = boundaries.Left To boundaries.Right
                If isInSelection(i, boundaries.Top + oldlinecount) Then
                    newselection(i, j) = seltiles(i, boundaries.Top + oldlinecount)
                    newbitfield(i, j) = True
                End If
            Next
            oldlinecount = oldlinecount + 1
        End If
    Next


    Dim newnewselection(1024, 1024) As Integer
    Dim newnewbitfield(1024, 1024) As Boolean

    Dim nrOfLinesOnY As Integer
    nrOfLinesOnY = Round(((Right - Left) - (boundaries.Right - boundaries.Left)))
    If nrOfLinesOnY < 0 Then
        shrink = True
        nrOfLinesOnY = Abs(nrOfLinesOnY)
    Else
        shrink = False
    End If

    Dim bnds As RECT
    bnds.Left = Left
    bnds.Top = Top
    bnds.Right = boundaries.Right
    bnds.Bottom = Bottom

    oldlinecount = 0
    j = Left
    For j = Left To Right
        If (j - Left) Mod Round((Right - Left) / nrOfLinesOnY) = 0 And j <> Left And j <> Right Then
            'we need to add/remove a line
            'check which of lines previous and next has the most
            '0 tiles
            prevnr = TileCountOnLine(bnds.Left + oldlinecount - 1, 0, True, bnds)
            nextnr = TileCountOnLine(bnds.Left + oldlinecount, 0, True, bnds)
            nextnextnr = TileCountOnLine(bnds.Left + oldlinecount + 1, 0, True, bnds)
            If shrink Then
                'skip a line
                oldlinecount = oldlinecount + 1

                If prevnr <= nextnr And prevnr <> 0 Then    'And bnds.left + oldlinecount - 1 <= bnds.right Then
                    curline = oldlinecount - 1
                Else
                    curline = oldlinecount
                End If

                'draw the line
                i = bnds.Top
                For i = bnds.Top To bnds.Bottom
                    If newbitfield(bnds.Left + curline, i) Then
                        newnewselection(j, i) = newselection(bnds.Left + curline, i)
                        newnewbitfield(j, i) = True
                    End If
                Next
                oldlinecount = oldlinecount + 1
            Else
                'check which line to use
                If prevnr >= nextnr And prevnr <> 0 Then    'And bnds.left + oldlinecount - 1 <= bnds.right Then
                    If prevnr >= nextnextnr Then
                        curline = oldlinecount - 1
                    Else
                        curline = oldlinecount + 1
                    End If
                Else
                    If nextnr >= nextnextnr Then
                        curline = oldlinecount
                    Else
                        curline = oldlinecount + 1
                    End If
                End If

                'draw the line
                i = bnds.Top
                For i = bnds.Top To bnds.Bottom
                    If newbitfield(bnds.Left + curline, i) Then
                        newnewselection(j, i) = newselection(bnds.Left + curline, i)
                        newnewbitfield(j, i) = True
                    End If
                Next
            End If
        Else
            i = bnds.Top
            For i = bnds.Top To bnds.Bottom
                If newbitfield(bnds.Left + oldlinecount, i) Then
                    newnewselection(j, i) = newselection(bnds.Left + oldlinecount, i)
                    newnewbitfield(j, i) = True
                End If
            Next
            oldlinecount = oldlinecount + 1
        End If
    Next

    bnds.Left = Left
    bnds.Top = Top
    bnds.Right = Right
    bnds.Bottom = Bottom

    seltiles = newnewselection
    isInSelection = newnewbitfield
    boundaries = bnds

    parent.pic1024selection.Cls
    Dim k As Integer
    Dim l As Integer
    For l = bnds.Top To bnds.Bottom
        For k = bnds.Left To bnds.Right
            Call SetPixel(parent.pic1024selection.hdc, k, l, TilePixelColor(seltiles(k, l)))
        Next
    Next
    parent.pic1024selection.refresh

    selectionchanged = True

    parent.UpdateLevel
End Sub

Friend Function TileCountOnLine(j As Integer, tile As Integer, vert As Boolean, boundaries As RECT)
    Dim i As Integer
    Dim count As Integer

    If vert Then
        For i = boundaries.Top To boundaries.Bottom
            If seltiles(j, i) = tile Then
                count = count + 1
            End If
        Next
    Else
        For i = boundaries.Left To boundaries.Right
            If seltiles(i, j) = tile Then
                count = count + 1
            End If
        Next
    End If
    TileCountOnLine = count
End Function

Sub ConverttoWalltiles(wallset As Integer)
    Dim i As Integer
    Dim j As Integer
    Dim val As Integer
    Dim tmp As Integer
    Dim checked() As Boolean

    Erase checked
    ReDim checked(boundaries.Left - 1 To boundaries.Right, boundaries.Top - 1 To boundaries.Bottom)

    For j = boundaries.Top To boundaries.Bottom
        For i = boundaries.Left To boundaries.Right
            'Check if it is possible to convert current tile
            If isInSelection(i, j) And IsValidForConvert(seltiles(i, j)) Then
                val = 0
                'Check right and under current tile
                If isInSelection(i + 1, j) And IsValidForConvert(seltiles(i + 1, j)) Then val = val + 1
                If isInSelection(i, j + 1) And IsValidForConvert(seltiles(i, j + 1)) Then val = val + 8

                'Check left and over if we already have checked this tile
                'This is to prevent problems when special tiles are used as walltiles (such as doors)
                If checked(i, j - 1) Then val = val + 2
                If checked(i - 1, j) Then val = val + 4

                'Set the tile if a walltile is defined for that value
                tmp = parent.walltiles.getWallTile(wallset, val)
                If tmp <> 0 Then seltiles(i, j) = tmp

                'Confirm that the tile was valid for conversion
                checked(i, j) = True
            End If
        Next
    Next

    parent.UpdateLevel

    selectionchanged = True

End Sub

Function IsValidForConvert(tilenr As Integer) As Boolean
    If tilenr <> 0 And tilenr <> -1 And tilenr <> 217 And tilenr <> 219 And tilenr <> 220 Then
        IsValidForConvert = True
    Else
        IsValidForConvert = False
    End If
End Function
