VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UndoRedoStack"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim undostack(9) As Changes
Dim redostack(9) As Changes

Public undocurpos As Integer
Public redocurpos As Integer

Dim parent As frmMain

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Private Sub Class_Initialize()
    undocurpos = 0
    redocurpos = 0
End Sub

Sub Undo()

    Call Process(undostack(undocurpos - 1), True)

    Set undostack(undocurpos - 1) = Nothing

    If undocurpos - 1 = 0 Then
        undocurpos = undocurpos - 1
        frmGeneral.toolbartop.Buttons("Undo").Enabled = False
        frmGeneral.mnuUndo.Enabled = False
    Else
        undocurpos = undocurpos - 1
    End If

End Sub

Sub Redo()
    Call Process(redostack(redocurpos - 1), False)

    Set redostack(redocurpos - 1) = Nothing
    If redocurpos - 1 = 0 Then
        redocurpos = redocurpos - 1
        frmGeneral.toolbartop.Buttons("Redo").Enabled = False
        frmGeneral.mnuRedo.Enabled = False
    Else
        redocurpos = redocurpos - 1
    End If
End Sub

Sub AddToUndo(undochanges As Changes)
'the undo stack is full, remove the first one so we can have
'room for the new one
    If undocurpos = UBound(undostack) + 1 Then
        undocurpos = UBound(undostack)
        Call sliceUndoStack
    End If

    Set undostack(undocurpos) = undochanges
    undocurpos = undocurpos + 1
    frmGeneral.toolbartop.Buttons("Undo").Enabled = True
    frmGeneral.mnuUndo.Enabled = True
End Sub

Sub AddToRedo(redochanges As Changes)
'the undo stack is full, remove the first one so we can have
'room for the new one
    If redocurpos = UBound(redostack) + 1 Then
        redocurpos = UBound(redostack)
        Call sliceRedoStack
    End If

    Set redostack(redocurpos) = redochanges
    redocurpos = redocurpos + 1
    frmGeneral.toolbartop.Buttons("Redo").Enabled = True
    frmGeneral.mnuRedo.Enabled = True
End Sub

Sub sliceUndoStack()
    Dim i As Integer
    For i = 1 To UBound(undostack)
        Set undostack(i - 1) = undostack(i)
    Next
    Set undostack(9) = Nothing
End Sub

Sub sliceRedoStack()
    Dim i As Integer
    For i = 1 To UBound(redostack)
        Set redostack(i - 1) = redostack(i)
    Next
    Set redostack(9) = Nothing
End Sub

Sub Process(change As Changes, Undo As Boolean)

    On Error GoTo Process_Error


    ' tool:X,Y,TILE:X,Y,TILE:X,Y,TILE:....
    If Not IsObject(change) Then Exit Sub

    Dim i As Long
    Dim urstr As New Changes

    Dim objecttoset() As Long
    ReDim objecttoset(20)
    Dim objcount As Integer

    For i = change.UBnd To 0 Step -1
        Dim tmp() As Integer
        tmp = change.GetChange(i)

        If tmp(2) = 217 Or tmp(2) = 219 Or tmp(2) = 220 Then
            If objcount > UBound(objecttoset) Then
                ReDim Preserve objecttoset(UBound(objecttoset) + 50)
            End If
            objecttoset(objcount) = i
            objcount = objcount + 1
        Else
            Call parent.setTile(tmp(0), tmp(1), tmp(2), urstr)
            Call parent.UpdateLevelTile(tmp(0), tmp(1), False)
        End If

    Next

    i = 0
    For i = 0 To objcount - 1
        tmp = change.GetChange(objecttoset(i))

        Call setObject(parent, tmp(2), tmp(0), tmp(1), urstr, False)
    Next

    If Undo Then
        Call AddToRedo(urstr)
    Else
        Call AddToUndo(urstr)
    End If

    Call parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

Process_Error:

    'MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Process of Class Module UndoRedoStack"

End Sub


Sub ResetRedo()

    On Error GoTo ResetRedo_Error

    Dim i As Integer
    For i = redocurpos - 1 To UBound(redostack)
        If i >= 0 Then
            Set redostack(i) = Nothing
            frmGeneral.toolbartop.Buttons("Redo").Enabled = False
            frmGeneral.mnuRedo.Enabled = False
        End If
    Next
    redocurpos = 0

    On Error GoTo 0
    Exit Sub

ResetRedo_Error:

    'MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ResetRedo of Class Module UndoRedoStack"

End Sub

Sub ResetUndo()

    On Error GoTo ResetUndo_Error

    Dim i As Integer
    For i = undocurpos - 1 To UBound(undostack)
        If i >= 0 Then
            undostack(i) = ""
            frmGeneral.toolbartop.Buttons("Undo").Enabled = False
            frmGeneral.mnuUndo.Enabled = False
        End If
    Next
    undocurpos = 0

    On Error GoTo 0
    Exit Sub

ResetUndo_Error:

    'MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ResetUndo of Class Module UndoRedoStack"
End Sub
